org.apache.lucene.analysis

## Class TokenStream

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream

- All Implemented Interfaces:
    Closeable, AutoCloseable
  Direct Known Subclasses:
    NumericTokenStream, TokenFilter, Tokenizer

      public abstract class TokenStream
      extends AttributeSource
      implements Closeable

  A `TokenStream` enumerates the sequence of tokens, either from `Field`s of a `Document` or from query text.

  This is an abstract class; concrete subclasses are:

  - `Tokenizer`, a `TokenStream` whose input is a Reader; and
  - `TokenFilter`, a `TokenStream` whose input is another `TokenStream`.
  A new `TokenStream` API has been introduced with Lucene 2.9. This API has moved from being `Token`-based to `Attribute`-based. While `Token` still exists in 2.9 as a convenience class, the preferred way to store the information of a `Token` is to use `AttributeImpl`s.

  `TokenStream` now extends `AttributeSource`, which provides access to all of the token `Attribute`s for the `TokenStream`. Note that only one instance per `AttributeImpl` is created and reused for every token. This approach reduces object creation and allows local caching of references to the `AttributeImpl`s. See `incrementToken()` for further details.

  The workflow of the new `TokenStream` API is as follows:

  1. Instantiation of `TokenStream`/`TokenFilter`s which add/get attributes to/from the `AttributeSource`.
  2. The consumer calls `reset()`.
  3. The consumer retrieves attributes from the stream and stores local references to all attributes it wants to access.
  4. The consumer calls `incrementToken()` until it returns false consuming the attributes after each call.
  5. The consumer calls `end()` so that any end-of-stream operations can be performed.
  6. The consumer calls `close()` to release any resource when finished using the `TokenStream`.
  To make sure that filters and consumers know which attributes are available, the attributes must be added during instantiation. Filters and consumers are not required to check for availability of attributes in `incrementToken()`.

  You can find some example code for the new API in the analysis package level Javadoc.

  Sometimes it is desirable to capture a current state of a `TokenStream`, e.g., for buffering purposes (see `CachingTokenFilter`, TeeSinkTokenFilter). For this usecase `AttributeSource.captureState()` and `AttributeSource.restoreState(org.apache.lucene.util.AttributeSource.State)` can be used.

  The `TokenStream`-API in Lucene is based on the decorator pattern. Therefore all non-abstract subclasses must be final or have at least a final implementation of `incrementToken()`! This is checked when Java assertions are enabled.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

      `AttributeSource.State`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static AttributeFactory` | `DEFAULT_TOKEN_ATTRIBUTE_FACTORY` Default `AttributeFactory` instance that should be used for TokenStreams.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `TokenStream()` A TokenStream using the default attribute factory.
    `protected` | `TokenStream(AttributeFactory factory)` A TokenStream using the supplied AttributeFactory for creating new `Attribute` instances.
    `protected` | `TokenStream(AttributeSource input)` A TokenStream that uses the same attributes as the supplied one.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Releases resources associated with this stream.
    `void` | `end()` This method is called by the consumer after the last token has been consumed, after `incrementToken()` returned `false` (using the new `TokenStream` API).
    `abstract boolean` | `incrementToken()` Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token.
    `void` | `reset()` This method is called by a consumer before it begins consumption using `incrementToken()`.

    - ### Methods inherited from class org.apache.lucene.util.AttributeSource

      `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, endAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, removeAllAttributes, restoreState, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_TOKEN_ATTRIBUTE_FACTORY

          public static final AttributeFactory DEFAULT_TOKEN_ATTRIBUTE_FACTORY

      Default `AttributeFactory` instance that should be used for TokenStreams.

  - ### Constructor Detail

    - #### TokenStream

          protected TokenStream()

      A TokenStream using the default attribute factory.

    - #### TokenStream

          protected TokenStream(AttributeSource input)

      A TokenStream that uses the same attributes as the supplied one.

    - #### TokenStream

          protected TokenStream(AttributeFactory factory)

      A TokenStream using the supplied AttributeFactory for creating new `Attribute` instances.

  - ### Method Detail

    - #### incrementToken

          public abstract boolean incrementToken()
                                          throws IOException

      Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token. Implementing classes must implement this method and update the appropriate `AttributeImpl`s with the attributes of the next token.

      The producer must make no assumptions about the attributes after the method has been returned: the caller may arbitrarily change it. If the producer needs to preserve the state for subsequent calls, it can use `AttributeSource.captureState()` to create a copy of the current attribute state.

      This method is called for every token of a document, so an efficient implementation is crucial for good performance. To avoid calls to `AttributeSource.addAttribute(Class)` and `AttributeSource.getAttribute(Class)`, references to all `AttributeImpl`s that this stream uses should be retrieved during instantiation.

      To ensure that filters and consumers know which attributes are available, the attributes must be added during instantiation. Filters and consumers are not required to check for availability of attributes in `incrementToken()`.

      Returns:
        false for end of stream; true otherwise
      Throws:
        `IOException`

    - #### end

          public void end()
                   throws IOException

      This method is called by the consumer after the last token has been consumed, after `incrementToken()` returned `false` (using the new `TokenStream` API). Streams implementing the old API should upgrade to use this feature.

      This method can be used to perform any end-of-stream operations, such as setting the final offset of a stream. The final offset of a stream might differ from the offset of the last token eg in case one or more whitespaces followed after the last token, but a WhitespaceTokenizer was used.

      Additionally any skipped positions (such as those removed by a stopfilter) can be applied to the position increment, or any adjustment of other attributes where the end-of-stream value may be important.

      If you override this method, always call `super.end()`.

      Throws:
        `IOException` - If an I/O error occurs

    - #### reset

          public void reset()
                     throws IOException

      This method is called by a consumer before it begins consumption using `incrementToken()`.

      Resets this stream to a clean state. Stateful implementations must implement this method so that they can be reused, just as if they had been created fresh.

      If you override this method, always call `super.reset()`, otherwise some internal state will not be correctly reset (e.g., `Tokenizer` will throw `IllegalStateException` on further usage).

      Throws:
        `IOException`

    - #### close

          public void close()
                     throws IOException

      Releases resources associated with this stream.

      If you override this method, always call `super.close()`, otherwise some internal state will not be correctly reset (e.g., `Tokenizer` will throw `IllegalStateException` on reuse).

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Throws:
        `IOException`

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.